import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;

/**
 * Diese Klasse repraesentiert das Hauptfenster der Praedikat-Hausaufgabe.
 * 
 * @author Annabelle Klarl
 */
public class PraedikatFrameH extends JFrame implements ActionListener {
    private JButton palindromButton;

    private JTextArea ausgabeBereich;

    /**
     * In diesem Programmstueck wird das Fenster erzeugt
     */
    public PraedikatFrameH() {
        /* In der Kopfleiste des Fenster steht "PraedikatFrameH" */
        this.setTitle("PraedikatFrameH");

        /* Das Fenster ist 500 Pixel breit und 150 Pixel hoch. */
        this.setSize(500, 150);

        /* Hier werden alle Buttons erzeugt. */
        this.palindromButton = new JButton("Ist Array ein Palindrom?");

        /* Hier wird der Ausgabe-Bereich erzeugt. */
        this.ausgabeBereich = new JTextArea(10, 100);

        /*
         * Der ContentPane ist der Ausschnitt des Fensters, auf dem Widgets d.h.
         * Interaktionselemente (wie eine TextArea oder ein Button) platziert
         * werden koennen.
         */
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new GridLayout(2, 1));
        /* Hier wird die Gruppe von Buttons platziert. */
        contentPane.add(this.palindromButton);
        /* Hier wird der Ausgabebereich platziert. */
        contentPane.add(this.ausgabeBereich);

        /*
         * Hier wird der Frame als Listener fuer Knopfdruck-Ereignisse bei jedem
         * der Buttons registriert.
         */
        this.palindromButton.addActionListener(this);

        /*
         * Wird das Fenster geschlossen (d.h. auf X gedrueckt), wird mit Hilfe
         * dieser Programmzeile auch unser Programm ordnungsgemaess beendet.
         */
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        // je nach Button entsprechende Methode ausfuehren
        Object source = e.getSource();
        if (source == this.palindromButton) {
            this.palindrom();
        }
    }

    /**
     * implementiert die Funktionalitaet des "Palindrom"-Buttons
     */
    private void palindrom() {
        String einlesenArray = JOptionPane
                .showInputDialog("char-Array: ");
        char[] array = KonverterErweitert
                .konvertiereZuCharArray(einlesenArray);

        boolean istPalindrom = istPalindrom(array);

        String eingabe = "Eingabe: " + einlesenArray + "\n\n";
        String ergebnis;
        if (istPalindrom) {
            ergebnis = eingabe + "Das Array ist ein Palindrom.";
        } else {
            ergebnis = eingabe + "Das Array KEIN Palindrom.";
        }
        this.ausgabeBereich.setText(ergebnis);
    }

    /**
     * testet, ob das Array palindromisch angeordnet ist
     * 
     * @param array
     * @return
     */
    private static boolean istPalindrom(char[] array) {
        for (int i = 0; i < array.length / 2; i++) {
            if (array[i] != array[array.length - 1 - i]) {
                return false;
            }
        }
        return true;
    }
}
